;      	
;   DS1621  DS1631
	list p=16f628a
	#include<P16F628a.inc>


 __CONFIG _CP_OFF & _WDT_ON & _BODEN_OFF & _PWRTE_ON & _XT_OSC & _LVP_OFF & _MCLRE_OFF
	  



;   flag
ERR1	equ	0	;   
ERR2	equ	1	;   
ER1_2	equ	2	;   
W_CONF	equ	3	;    -
FTDL	equ	4	;  First Time Determine Limits
CL2	equ	5	;  Correct Limits
Ts	equ	6	; 1 -     , 0 -   
R_CONF	equ	7	;   - 

;   flag1
lw	equ	0	;  1   
dat_1	equ	1	;   1
dat_2	equ	2	;   2
RETT	equ	3	;    - 
TT	equ	4	;    
SB1	equ	5	;   
START	equ	6	;    
IZM	equ	7	;    A_Temper  V_SPEED


;   flag2
REG	equ	0	; 1 -  , 0 - 
KO	equ	1	; 1 -  , 0 - 
KZ	equ	2	; 1 -  , 0 -  
Hi	equ	3	; 1 - , 0 - 
AOFF	equ	4	;      
DOFF	equ	5	;      
W_VENT	equ	6	;    
;	equ	7	; 


A_S_min	equ	.1	;       
A_S_max	equ	.2	;       

C1	equ	.2	;  (     )    
C2	equ	.3	;      
C4	equ	.2	;       

v_max	equ	.5	; max  
tt_ind	equ	.20	;     
bip	equ	.255	;    

tt1	equ	.7	;    TMR0
CONST1	equ	.0	;  / A_Temper  Ts_copy  
CONST2	equ	.0	;  / Ts_copy  A_Temper  
Time_H	equ	.24	; 3  -   
Del_H	equ	.2	; 0.25 -      ,   
SB1_H	equ	.24	; 3 -      
T_Max	equ	.31	;      (T_max-1)
T_Min	equ	.14	;      (T_min+1)

;***************************************************************
#define		ZAGIG		PORTA,0
#define		Buton		PORTA,1
#define 	pDOUT 		PORTA,2	
#define		pC1OUT		PORTA,3
#define		pC2OUT		PORTA,4

#define		SDA		PORTB,0	;  SDA 
#define		SOUND		PORTB,1	;   
#define		SCL		PORTB,2	;  SCL 
#define		CLOSED		PORTB,3
#define		OPEN		PORTB,4
#define		pVENT		PORTB,5	;    


#define		TRIS_SDA	TRISB,0
#define		TRIS_SCL	TRISB,2
;***************************************************************

;***************************************************************
;  
;***************************************************************
	cblock   H'20'	;  ,   EEPROM

	V_SPEED		; 20h  
	A_Temper	; 21h   
	flag2		; 22h    "-", -  

	handl		; 23h 3=0 -  , 3=1 - 
	VENT_COPY	; 24h 

	A_Des		; 25h "" ,  
	A_Ed		; 26h "" ,  

	SENSORS		; 27h 
	Treg		; 28h       
	Des		; 29h       
	Ed		; 2Ah       
	Ts_copy		; 2Bh      - 
	SHIM_H		; 2Ch      -  
	SHIM_P		; 2Dh    -
	tim_IND		; 2Eh    

	endc

;***************************************************************	
	cblock	h'30'
	PATH_COPY	; 30h
	IND1	 	; 31h	
	IND2		; 32h
	IND3		; 33h	
	ANODS		; 34h	
	counter		; 35h 
	nom_IND		; 36h    . 
	flag1		; 37h  
	TEMP1		; 38h    8- 
	FSR_copy	; 39h
	STATUS_copy	; 3Ah	
	IND_VENT	; 3Bh
	A_Copy		; 3Ch
	T_BIP		; 3Dh
	IDEN_COPY	; 3Eh
	DOP		; 3Fh	
	endc

;***************************************************************
	cblock   H'40'
	TRANSM		; 40	;     .
	flag		; 41	;    .
	Tsal		; 42	;   
	Tvoz		; 43	;   
	Tv_v		; 44	;      
	Tv_n		; 45	;       
	MSBYTE		; 46	;       
	LSBYTE		; 47	;       .
	Tper		; 48	; 
	count_D		; 49	;   .
	COUNT_BY	; 4A	;  .
	COUNT_BI	; 4B	;  .
	count_RE	; 4C	; 



	endc
;***************************************************************	
	cblock	h'50'

	TIME_MT_L	; 50     
	TIME_MT_H	; 51     
	T_Delay_L	; 52      
	T_Delay_H	; 53      
	T_SEC_L		; 54    / 
	T_SEC_H		; 55    / 
	T_SB1_L		; 56       SB1
	T_SB1_H		; 57       SB1
	T_Wait_L	; 58      
	T_Wait_H	; 59      
			; 5A
			; 5B
			; 5C
			; 5D
	D_temp		; 5E
			; 5F

	endc


;***************************************************************	
;***************************************************************	
	cblock	h'70'

	IDEN		; 70
	w_copy		; 71
	TRANS		; 72

	endc
;***************************************************************


;***************************************************************
	org	2100h
	DE	h'1',h'14',h'1',h'0'
	org	0x00
	goto	init ; ttrr 
yty	org	0x04
ne	btfss	INTCON,T0IF	;   TMR0
	goto	snp
int1	goto	preryv
snp	bcf	INTCON,0	;  
	bcf	INTCON,1	;  
	bcf	INTCON,2	;   
	retfie


;***************************************************************
; 
;***************************************************************
S_COPY	macro	s2,s3,s4,s5,s6	;     W, STATUS  FSR
	movwf	s2		;  W
	swapf	s3,0		;
	movwf	s4
	swapf	s5,0
	movwf	s6
	endm
;***************************************************************
WR_COPY	macro	wr1,wr2,wr3,wr4,wr5
	swapf	wr1,0
	movwf	wr2
	swapf	wr3,0
	movwf	wr4
	swapf	wr5,1
	swapf	wr5,0
	endm
;***************************************************************
PER	macro	pp1,vv1		;  
	movfw	vv1		;   
	movwf	pp1		;  
	endm
;***************************************************************
PREOBR	macro	PREO1,PREO2,PREO3	
	local	lp1_PR, lp2_PR, lp3_PR, ext_PRE
	clrwdt
	clrf	PREO2
	clrf	PREO3
	movf	PREO1,1
	btfss	STATUS,Z
	goto	lp1_PR
	goto	ext_PRE
lp3_PR	incf	PREO2,1
lp1_PR	movlw	.10
	subwf	PREO1,1
	btfss	STATUS,Z
	goto	lp2_PR
	incf	PREO2,1
	goto	ext_PRE
lp2_PR	btfsc	STATUS,C
	goto	lp3_PR
	movlw	.10
	addwf	PREO1,0
	movwf	PREO3
	clrf	PREO1
ext_PRE
	endm

;***************************************************************
DAT_OUT	macro	DD,sd,CC,sc		;   
	local	agane1, set_hi1, takt	;   "DD"  sd
	movwf	D_temp			;  -  ""  s
	movlw	.8			;   1 
	movwf	TEMP1
agane1	bcf	CC,sc
	bcf	STATUS,C
	rrf	D_temp,1
	movfw	D_temp
	btfsc	STATUS,C
	goto	set_hi1
	bcf	DD,sd
	goto	takt
set_hi1	bsf	DD,sd
takt	bsf	CC,sc
	decfsz	TEMP1,1
	goto	agane1
	endm
	
;***************************************************************


DECODER	
;	addlw	.1
	addwf	PCL,1
	;	  abcdefgh
	retlw	b'11111100'	; 0 
	retlw	b'01100000'	;1
	retlw	b'11011010'	;2 
	retlw	b'11110010'	;3
	retlw	b'01100110'	;4
	retlw	b'10110110'	;5
	retlw	b'10111110'	;6
	retlw	b'11100000'	;7
	retlw	b'11111110'	;8
	retlw	b'11110110'	;9
;	retlw	b'11000110'	;  
;	retlw	b'00000010'	; ""




VENT_IND			;   
	addwf	PCL,1
	retlw	b'00000000'	;  
	retlw	b'10000000'	; 1 
	retlw	b'11000000'	; 2 
	retlw	b'11100000'	; 3 
	retlw	b'11110000'	; 4 
	retlw	b'11111000'	; 5 

ANOD_IND
	addwf	PCL,1
	nop
	retlw	b'00000100'	; 1  
	retlw	b'00000010'	; 2 
	retlw	b'00000001'	; 3 

;------------------------------------------------------------
;    ""
;------------------------------------------------------------
IND_OP	movlw	b'00010000'
	movwf	IND1
	movlw	b'00010010'		;      _
	movwf	IND2			;    _ _  ""
	movlw	b'10010010'		;  _ _ _
	movwf	IND3
	return
;------------------------------------------------------------
;    ""
;------------------------------------------------------------
IND_CL	movlw	b'00010000'
	movwf	IND3
	movlw	b'00010010'		;  _
	movwf	IND2			;  _ _    ""
	movlw	b'10010010'		;  _ _ _
	movwf	IND1
	return
;------------------------------------------------------------
;     V_SPEED
;------------------------------------------------------------
DOP_SPEED
	movf	V_SPEED,1
	btfsc	STATUS,Z
	return
	movlw	v_max
	movwf	DOP
D_1_1	movfw	V_SPEED
	xorwf	DOP,0
	btfsc	STATUS,Z
	return
	decfsz	DOP,1
	goto	D_1_1
	clrf	V_SPEED
	return
;------------------------------------------------------------
;     A_Temper
;------------------------------------------------------------
DOP_A_Temper
	movlw	T_Max
	movwf	DOP
DA_2_1	movfw	A_Temper
	subwf	DOP,0
	btfsc	STATUS,Z
	return
	decf	DOP,1
	movlw	T_Min
	subwf	DOP,0
	btfss	STATUS,Z
	goto	DA_2_1
	movlw	T_Min
	movwf	A_Temper
	movlw	.1
	movwf	A_Des
	movlw	.4
	movwf	A_Ed
	return

;------------------------------------------------------------
;  
;------------------------------------------------------------
KranOFF	bcf	OPEN
	btfss	handl,3
	goto	K_OF_1
	movlw	A_S_min
	movwf	V_SPEED
K_OF_1	bcf	flag2,Hi		;  ""
	btfsc	flag2,KZ		;   ?
	return				;  	
	bsf	flag2,KZ		;  -  
	bcf	flag2,KO		
	movlw	.8
	movwf	T_SEC_H	
	bsf	CLOSED	
	return
;------------------------------------------------------------	
; 
;------------------------------------------------------------
KranON	bcf	CLOSED	
	btfss	handl,3
	goto	K_ON_1
	movlw	A_S_max
	movwf	V_SPEED
K_ON_1	bsf	flag2,Hi		;  ""
	btfsc	flag2,KO		;   ?
	return				;  
	bsf	flag2,KO		;  -  
	bcf	flag2,KZ		
	movlw	.8			
	movwf	T_SEC_H
	bsf	OPEN
	return
;------------------------------------------------------------

;     1
DATCH1
	clrwdt
	btfsc	flag1,dat_2
	goto	d_1_1
	bsf	flag1,dat_1
	movlw	Del_H
	movwf	T_Delay_H
	return
d_1_1	bcf	flag1,dat_1
	bcf	flag1,dat_2
	movlw	Del_H
	movwf	T_Wait_H
	bsf	SOUND
	movlw	bip
	movwf	T_BIP
	clrf	T_Delay_H
	movlw	.250
	movwf	T_Delay_L
	movwf	T_SB1_L
	movlw	SB1_H
	movwf	T_SB1_H
	movlw	Time_H
	movwf	TIME_MT_H
	movlw	.250
	movwf	TIME_MT_L
	bsf	flag1,IZM
	btfsc	flag1,SB1
	goto	DECRER
	clrf	handl
	bcf	flag1,SB1
	call	DOP_SPEED
	movf	V_SPEED,1
	btfsc	STATUS,Z
	goto	V_D_1	
	decf	V_SPEED,1
	return
V_D_1	bcf	SOUND
	return
DECRER	btfss	flag,ER1_2
	goto	DECRE1
	call	KranOFF
	call	IND_CL
	movlw	b'11001110'		; 'P' -  
	movwf	IND1
	return
DECRE1	movlw	.250
	movwf	T_Delay_L
	movwf	T_SB1_L
	movlw	SB1_H
	movwf	T_SB1_H
	btfsc	flag2,DOFF
	goto	DE1
	btfss	flag2,AOFF
	goto	DE_1
	bcf	flag2,AOFF
	bsf	flag,Ts
	bcf	flag,FTDL
	bsf	flag2,REG
	movlw	b'11001110'		; 'P' -  
	movwf	IND1	
DE_1	movf	Tv_v,1
	btfsc	STATUS,Z
	goto	DE0
	decf	Tv_v,1
	decf	Tv_n,1
	bcf	flag,Ts
	bsf	flag,FTDL
	bcf	flag,CL2
DE0	decf	A_Temper,1
	call	DOP_A_Temper
	movlw	T_Min
	subwf	A_Temper,0
	btfss	STATUS,Z
	goto	DE2
	clrf	Tv_v
	clrf	Tv_n
	bsf	flag2,DOFF
DE1	clrf	handl
	call	IND_CL
	movlw	b'11001110'		; 'P' -  
	movwf	IND1	
	bcf	flag2,REG
	call	KranOFF
	return
DE2	movfw	A_Temper
	movwf	A_Copy
	PREOBR	A_Temper, A_Des, A_Ed
	movfw	A_Copy
	movwf	A_Temper
	movfw	A_Des
	call	DECODER
	movwf	IND2
	movfw	A_Ed
	call	DECODER
	movwf	IND3
	return
;     1

;     2
DATCH2
	clrwdt
	btfsc	flag1,dat_1
	goto	d_2_1
	bsf	flag1,dat_2
	movlw	Del_H
	movwf	T_Delay_H
	return
d_2_1	bcf	flag1,dat_1
	bcf	flag1,dat_2
	movlw	Del_H
	movwf	T_Wait_H
	bsf	SOUND
	movlw	bip
	movwf	T_BIP
	clrf	T_Delay_H
	movlw	.250
	movwf	T_Delay_L
	movwf	T_SB1_L
	movlw	SB1_H
	movwf	T_SB1_H
	movlw	Time_H
	movwf	TIME_MT_H
	movlw	.250
	movwf	TIME_MT_L
	bsf	flag1,IZM
	btfsc	flag1,SB1
	goto	INCRER
	clrf	handl
	bcf	flag1,SB1
	call	DOP_SPEED
	movlw	v_max
	subwf	V_SPEED,0
	btfsc	STATUS,Z
	goto	V_I_1
	incf	V_SPEED,1
	return
V_I_1	bcf	SOUND
	return
INCRER	btfss	flag,ER1_2
	goto	INCRE1
	call	KranON
	call	IND_OP
	movlw	b'11001110'		; 'P' -  
	movwf	IND1
	return
INCRE1	movlw	.250
	movwf	T_Delay_L
	movwf	T_SB1_L
	movlw	SB1_H
	movwf	T_SB1_H
	btfsc	flag2,AOFF
	goto	IN1
	btfss	flag2,DOFF
	goto	IN_1
	bcf	flag2,DOFF
	bsf	flag,Ts
	bcf	flag,FTDL
	bsf	flag2,REG
	bcf	flag,CL2
	movlw	b'11001110'		; 'P' -  
	movwf	IND1	
IN_1	movf	Tv_v,1			;   
	btfsc	STATUS,Z		;  0 
	goto	IN0			;  
	incf	Tv_v,1
	incf	Tv_n,1
	bsf	flag,Ts
	bsf	flag,FTDL
	bcf	flag,CL2
IN0	incf	A_Temper,1
	call	DOP_A_Temper
	movlw	T_Max
	subwf	A_Temper,0
	btfss	STATUS,Z
	goto	IN2
	bsf	flag2,AOFF
	clrf	Tv_v
	clrf	Tv_n	
IN1	clrf	handl
	call	IND_OP
	movlw	b'11001110'		; 'P' -  
	movwf	IND1
	bcf	flag2,REG
	call	KranON
	return
IN2	movfw	A_Temper
	movwf	A_Copy
	PREOBR	A_Temper, A_Des, A_Ed
	movfw	A_Copy
	movwf	A_Temper
	movfw	A_Des
	call	DECODER
	movwf	IND2
	movfw	A_Ed
	call	DECODER
	movwf	IND3
	return
;     2

;===============================================================
;      DS1621
;===============================================================
;  
;  
STA	bsf	SCL
	bsf	SDA
	nop
	nop
	nop
	nop
	nop
	bcf	SDA
	nop
	nop
	nop
	nop
	nop
	bcf	SCL
	nop
	nop
	return

;--------------------------------------
; 
STO	bcf	SDA
	bsf	SCL
	nop
	nop
	nop
	nop
	nop
	bsf	SDA
	return
;--------------------------------------
; Ack-Slave
ACK_S	bsf	SCL
	nop
	nop
	nop
	btfss	SDA
	goto	ACK1
	btfsc	count_D,0
	goto	ACK3
	bsf	flag,ERR1
	bsf	flag,R_CONF
	nop
	goto	ACK2
ACK3	bsf	flag,ERR2
	bsf	flag,R_CONF
	goto	ACK2
ACK1	btfsc	count_D,0
	goto	ACK4
	bcf	flag,ERR1
	goto	ACK2
ACK4	bcf	flag,ERR2
	nop
ACK2	bcf	SCL
	nop
	bcf	SDA
	call	SDA_OUT
	return	
;--------------------------------------
; Ack-Master
ACK_M	call	SDA_OUT
	bcf	SDA
	nop
	bsf	SCL
	nop
	nop
	nop
	bcf	SCL
	call	SDA_IN
	return
;--------------------------------------
; Nack-Master
NACK_M	call	SDA_OUT
	bsf	SDA
	nop
	bsf	SCL
	nop
	nop
	nop
	bcf	SCL
	bcf	SDA
	return
	
;--------------------------------------
;   
CONFIGURATION			
	movlw	.2
	movwf	count_D
	call	STA
	movlw	b'10010010'
CON1	call	TX
	call	ACK_S
	movlw	b'10101100'
	call	TX
	call	ACK_S
	movlw	b'00000010'	; 1SHOT=0
	call	TX
	call	ACK_S
	call	STO
	decfsz	count_D,1
	goto	CON2
	return
CON2	call	STA
	movlw	b'10010100'
	goto	CON1
;--------------------------------------

;--------------------------------------
;     
PREOBRAZ_T	
	bcf	INTCON,GIE		
	movlw	.2
	movwf	count_D
	call	STA
	movlw	b'10010010'
PRE1	call	TX
	call	ACK_S
	movlw	0x51		;0x51 -  DS1631, 0xEE -  DS1621 0x51 -  DS1631
	call	TX
	call	ACK_S
	call	STO
	decfsz	count_D,1
	goto	PRE2
	bsf	INTCON,GIE
	return
PRE2	call	STA
	movlw	b'10010100'
	goto	PRE1	
;--------------------------------------


;--------------------------------------
;     
READ_T	
	movlw	.2
	movwf	count_D
REA1	call	STA
	btfss	count_D,1
	goto	RE_1
	movlw	b'10010010'
	goto	RE_2
RE_1	movlw	b'10010100'
RE_2	call	TX
	call	ACK_S
	movlw	b'10101010'
	call	TX
	call	ACK_S
	call	STA
	btfss	count_D,1
	goto	RE_3
	movlw	b'10010011'
	goto	RE_4
RE_3	movlw	b'10010101'
RE_4	call	TX
	call	ACK_S
	call	RX
	movwf	MSBYTE
	call	ACK_M
	call	RX
	movwf	LSBYTE
	call	NACK_M
	call	STO
	decfsz	count_D,1
	goto	REA2
	goto	REA3
REA2	movfw	MSBYTE
	movwf	Tvoz
	goto	REA1
REA3	movfw	MSBYTE
	movwf	Tsal
	return
;--------------------------------------
;    
TX
	movwf	TRANSM
	movlw	.8
	movwf	COUNT_BI
TX1	bcf	SCL
	btfsc	TRANSM,7
	goto	TX2
	bcf	STATUS,C
	bcf	SDA
	goto	TX3
TX2	bsf	STATUS,C
	bsf	SDA
TX3	rlf	TRANSM,1
	bsf	SCL
	nop
	nop
	nop
	nop
;	bcf	SCL
	decfsz	COUNT_BI,1
	goto	TX1
	call	SDA_IN
	bcf	SCL
;	bcf	SDA
	return	
;--------------------------------------
;    
RX
	clrf	TRANSM
	movlw	.8
	movwf	COUNT_BI
	call	SDA_IN
RX1	bsf	SCL
	nop
	nop
	btfss	SDA
	goto	RX2
	bsf	STATUS,C
	goto	RX3
RX2	bcf	STATUS,C
RX3	rlf	TRANSM,1
	bcf	SCL
	nop
	nop
	decfsz	COUNT_BI,1
	goto	RX1
	movfw	TRANSM
	return
;--------------------------------------
; SDA  
SDA_OUT	
	bsf	STATUS,RP0
	bcf	TRIS_SDA
	bcf	STATUS,RP0
	return
;--------------------------------------
; SDA  
SDA_IN
	bsf	STATUS,RP0
	bsf	TRIS_SDA
	bcf	STATUS,RP0
	return
;--------------------------------------
; SCL  
SCL_OUT
	bsf	STATUS,RP0
	bcf	TRIS_SCL
	bcf	STATUS,RP0
	return
;--------------------------------------
; SCL  
SCL_IN
	bsf	STATUS,RP0
	bsf	TRIS_SCL
	bcf	STATUS,RP0
	return

;===============================================================

;***************************************************************
; 
;***************************************************************	

init				;  
	clrwdt
	movlw	20h
	movwf	FSR
clear	clrf	INDF
	incf	FSR,1
	movlw	80h
	subwf	FSR,0
	btfss	STATUS,Z
	goto	clear 
	clrwdt
tr	movlw	.1
	movwf	nom_IND
	clrf	PORTA			;   
	movlw	0x07			;  
	movwf	CMCON			;   -  /
ttrr	bsf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	B'11100011'
	movwf	TRISA
	movlw	b'11000000'		;   , 
	movwf	OPTION_REG		;   TMR0, . . = 1:2
	movlw	B'11000000'		;  RB6, RB7  ,
	movwf	TRISB			;   
	movlw	B'00100000'		;     TMR0 
	movwf	INTCON			; 
	bcf	STATUS,RP0
	bcf	OPEN
	bcf	CLOSED
	bcf	SOUND
;	bcf	OBDUV
	movlw	tt_ind		
	movwf	tim_IND
	movlw	.5
	movwf	SHIM_P
	movlw	21h	
	movwf	IDEN
	movlw	.8
	movwf	TIME_MT_H
	movlw	.250
	movwf	TIME_MT_L
	movwf	T_Delay_L
	movwf	T_SEC_L
	movwf	T_Wait_L
	bsf	flag1,START
	bsf	flag,Ts
wwee	call	CONFIGURATION
	call	PREOBRAZ_T
;***************************************************************
;   
;***************************************************************
rettt	call	PERENOS_IN
	bcf	flag2,KZ		;     ,    
	bcf	flag2,KO		;      KranON  KranOFF
	bcf	flag2,W_VENT
	call	DOP_SPEED
	call	DOP_A_Temper
	movlw	tt1
	movwf	TMR0
	bsf	INTCON,GIE
	movfw	A_Temper
	movwf	A_Copy
	PREOBR	A_Temper, A_Des, A_Ed
	movfw	A_Copy
	movwf	A_Temper	
;cikl	btfsc	ZAGIG			;  ?
;	goto	next			;  -    
;l	bcf	INTCON,GIE		; 
;	clrwdt
;	bsf	STATUS,RP0
;	movlw	b'00010101'	
;	movwf	OPTION_REG		;    1:1
;	bcf	STATUS,RP0
;	clrf	TMR0
;	bsf	STATUS,RP0
;	movlw	b'00001101'	
;	movwf	OPTION_REG		;    WDT
;	bcf	STATUS,RP0
;	clrwdt	
;	bsf	STATUS,RP0
;	movlw	b'00001111'	
;	movwf	OPTION_REG		;   1:128
;	bcf	STATUS,RP0
;	clrwdt
;	bsf	SOUND
;	movfw	IDEN
;	movwf	IDEN_COPY
;ll	call	PERENOS_OUT		;  -     EEPROM
;	movfw	IDEN_COPY
;	movwf	IDEN
;	bcf	flag1,IZM
;	bcf	SOUND
;	bsf	INTCON,GIE
;sl1	sleep
;	nop
;	goto	sl1



cikl	clrwdt
	btfss	flag1,TT		;  ? 
	goto	SBPRES			;  - 
	call	T_IZM			;  -      

	btfss	flag1,IZM		;  A_Temper  V_SPEED ?
	goto	next
l	bcf	INTCON,GIE
	clrwdt
	movfw	IDEN
	movwf	IDEN_COPY
ll	call	PERENOS_OUT		;  -     EEPROM
	movfw	IDEN_COPY
	movwf	IDEN
	bcf	flag1,IZM
	bsf	INTCON,GIE

next	btfsc	flag,W_CONF
	goto	SBPRES				
	btfss	flag2,REG		;  ?
	goto	SBPRES			;  - 
	movlw	h'02'			; 
	movwf	PCLATH
	movlw	b'00000011'
	andwf	flag,0
	addwf	PCL,1
	goto	UPR1			;    
	goto	UPR1_2			;    
	goto	UPR1_1			;    
	goto	UPR1_3			;    /
;---------------------------------------

UPR1_1	movfw	PATH_COPY
	movwf	PCLATH	
	movfw	Tvoz			;    
	movwf	Treg
	btfsc	counter,0
	goto	UP_1_4
	movlw	b'01100000'		; '1'
	movwf	IND3
	goto	UP_1_8
UPR1_2	movfw	PATH_COPY
	movwf	PCLATH	
	movfw	Tsal			;    
	movwf	Treg
	btfsc	counter,0
	goto	UP_1_4
	movlw	b'11011010'		; '2'
	movwf	IND3
UP_1_8	movlw	b'01110110'		; ''
	movwf	IND1
	movlw	b'00101010'		; ''
	movwf	IND2	
UP_1_4	btfss	Treg,7			;   ?
	goto	UP_1_9			; , 
	goto	UP_1_6			; ,  
UP_1_9	btfss	flag2,Hi		; ?
	goto	UP_1_5			; 
	movlw	C4			; 
	addwf	A_Temper,0			
	subwf	Treg,0
	btfss	STATUS,C
	goto	UP_1_6
	call	KranOFF
	goto	SBPRES
UP_1_6	call	KranON
	goto	SBPRES	
UP_1_5	movfw	A_Temper
	subwf	Treg,0
	btfss	STATUS,C
	goto	UP_1_7
	btfsc	STATUS,Z
	goto	UP_1_7
	call	KranOFF
	goto	SBPRES
UP_1_7	call	KranON	
	goto	SBPRES
;---------------------------------------
UPR1_3
	movfw	PATH_COPY
	movwf	PCLATH	

	goto	SBPRES
;---------------------------------------

UPR1	movfw	PATH_COPY
	movwf	PCLATH
	btfsc	flag,Ts
	goto	UPR2
	movfw	A_Temper
	subwf	Tvoz,0
	btfss	STATUS,C
	goto	UPR9_1
	movfw	A_Temper
	subwf	Tsal,0
	btfss	STATUS,C
	goto	UPR9_1
	btfss	flag2,Hi
	goto	UPR3_1
	movfw	Tv_v
	subwf	Tvoz,0
	btfsc	STATUS,C
	goto	UPR4
	goto	UPR9_2
UPR3_1	movfw	Tvoz
	subwf	Tv_n,0
	btfsc	STATUS,C
	goto	UPR3_2
	goto	UPR9
UPR3_2	btfss	flag,CL2
	goto	UPR3_3
	bcf	flag,CL2
	goto	UPR9_2
UPR3_3	movlw	C4+.1
	addwf	A_Temper,0
	subwf	Tsal,0
	btfss	STATUS,C
	goto	UPR9_2
	bsf	flag,CL2
	goto	UPR6_1
UPR2	btfsc	Tvoz,7
	goto	UPR9_1
	btfsc	Tsal,7
	goto	UPR9_1
UPR4	movfw	A_Temper
	subwf	Tvoz,0
	btfss	STATUS,C
	goto	UPR9_1
	movfw	A_Temper
	subwf	Tsal,0
	btfss	STATUS,C
	goto	UPR9_1
	btfsc	STATUS,Z
	goto	UPR5
	sublw	C4
	btfss	STATUS,C
	goto	UPR6
UPR5	btfsc	flag,FTDL
	goto	UPR8
	bsf	flag,FTDL
	movfw	Tvoz
	movwf	Tv_v
UPR7	movlw	C1
	subwf	Tv_v,0
	movwf	Tv_n
	movfw	A_Temper
	subwf	Tv_n,0
	btfsc	STATUS,C
	goto	UPR8
UPR7_1	movfw	A_Temper
	movwf	Tv_n
	movlw	C1
	addwf	Tv_n,0
	movwf	Tv_v
	goto	UPR8
UPR6	btfsc	flag,FTDL
	goto	UPR6_1
	bsf	flag,FTDL
	movlw	C2
	subwf	Tvoz,0
	movwf	Tv_v
	goto	UPR7
UPR6_1	movlw	C2
	subwf	Tv_v,1
	goto	UPR7
UPR8	bcf	flag,Ts
	movfw	Tv_v
	subwf	Tvoz,0
	btfsc	STATUS,C
	goto	UPR9
	goto	UPR9_2

UPR9	call	KranOFF
	goto	SBPRES	
	
UPR9_1	bsf	flag,Ts
	bcf	flag,FTDL
	bcf	flag,CL2
UPR9_2	call	KranON
	goto	SBPRES

SBPRES	btfsc	flag1,START
	goto	start1
	btfsc	flag1,SB1
	goto	sbp1
	btfsc	Buton
	goto	sbp1
start1	bcf	flag1,START
	bsf	flag1,SB1
	btfsc	flag2,REG
	goto	pr_1
	btfss	flag2,DOFF
	goto	pr_1_A
	call	IND_CL
	goto	sbp1
pr_1_A	btfss	flag2,AOFF
	goto	pr_1
	call	IND_OP
	goto	sbp1
	
pr_1	btfss	flag2,DOFF
	goto	pr_A
	call	IND_CL
	movlw	b'11001110'
	movwf	IND1
	goto	st_1
pr_A	btfss	flag2,AOFF
	goto	pr_O
	call	IND_OP
	movlw	b'11001110'
	movwf	IND1
	goto	st_1
pr_O	btfss	handl,3
	goto	I_R
	movlw	b'11101110'
	movwf	IND1
	goto	I_A
I_R	movlw	b'11001110'
	movwf	IND1
I_A	movfw	A_Des
	call	DECODER
	movwf	IND2
	movfw	A_Ed
	call	DECODER
	movwf	IND3
st_1	movlw	.250
	movwf	T_SB1_L
	movlw	SB1_H
	movwf	T_SB1_H
	movlw	.250
	movwf	TIME_MT_L
	movlw	Time_H
	movwf	TIME_MT_H
sbp1	movf	T_Wait_H,1		;     ?
	btfss	STATUS,Z
	goto	cikl			;  - .
	movfw	PORTB			;  - 
	movwf	SENSORS
	movlw	b'11000000'
	andwf	SENSORS,1
	movlw	b'11000000'
	subwf	SENSORS,0
	btfsc	STATUS,Z
	goto	cikl
sbp2	btfsc	flag1,dat_1
	goto	sbp3
	movlw	b'10000000'
	subwf	SENSORS,0
	btfsc	STATUS,Z
	call	DATCH1
sbp3	btfsc	flag1,dat_2
	goto	cikl
	movlw	b'01000000'
	subwf	SENSORS,0
	btfsc	STATUS,Z
	call	DATCH2	
	goto	cikl



;***************************************************************
preryv			;    TMR0
	local	REG_O,REG_Z,REG_R,ID,POINT	;   
	S_COPY	w_copy,STATUS,STATUS_copy,FSR,FSR_copy
	clrwdt
	nop
	movlw	tt1	 
	addwf	TMR0,1
P_T0_1	movf	T_SB1_H,1
	btfsc	STATUS,Z
	goto	P_T0_2
	decfsz	T_SB1_L,1
	goto	P_T0_2
	movlw	.250
	movwf	T_SB1_L
	btfss	flag,ER1_2
	btfsc	Buton
	goto	h_1
	incf	handl,1
	movlw	SB1_H
	movwf	T_SB1_H
	btfss	handl,3
	goto	P_I_R
	movlw	b'11101110'
	movwf	IND1
	bsf	flag1,IZM
	goto	P_T0_2
P_I_R	movlw	b'11001110'
	movwf	IND1
	bsf	flag1,IZM
	goto	P_T0_2
h_1	bcf	handl,0
	bcf	handl,1
	bcf	handl,2
	decfsz	T_SB1_H,1
	goto	P_T0_2
	bcf	flag1,SB1
	bsf	flag1,TT
P_T0_2	movf	T_SEC_H,1
	btfsc	STATUS,Z
	goto	P_T0_3
	decfsz	T_SEC_L,1
	goto	P_T0_3
	movlw	.250
	movwf	T_SEC_L
	decfsz	T_SEC_H,1
	goto	P_T0_3
	bcf	CLOSED
	bcf	OPEN
P_T0_3	movf	T_Delay_H,1
	btfsc	STATUS,Z
	goto	P_T0_4
	decfsz	T_Delay_L,1
	goto	P_T0_4
	movlw	.250
	movwf	T_Delay_L
	decfsz	T_Delay_H,1
	goto	P_T0_4
	bcf	flag1,dat_1
	bcf	flag1,dat_2
	bcf	SOUND

P_T0_4	movf	T_Wait_H,1
	btfsc	STATUS,Z
	goto	P_T0_5
	decfsz	T_Wait_L,1
	goto	P_T0_5
	movlw	.250
	movwf	T_Wait_L
	decfsz	T_Wait_H,1
	goto	P_T0_5
	bcf	SOUND

P_T0_5	movf	T_SB1_H,1
	btfss	STATUS,Z
	goto	P_T0_8	
P_T0_6	decfsz	TIME_MT_L,1
	goto	P_T0_8
	movlw	.250
	movwf	TIME_MT_L
	decfsz	TIME_MT_H,1
	goto	P_T0_8
	movlw	Time_H
	movwf	TIME_MT_H
	bsf	flag1,TT
	bsf	flag2,W_VENT
;  - 
P_T0_8	btfss	flag2,W_VENT
	goto	P_T0_13
	movlw	v_max
	subwf	V_SPEED,0
	btfss	STATUS,Z
	goto	P_T0_9
	bsf	pVENT
	goto	P_T0_13
P_T0_9	movf	V_SPEED,1
	btfss	STATUS,Z
	goto	P_T0_10
	bcf	pVENT
	goto	P_T0_13
P_T0_10	movf	SHIM_H,1
	btfss	STATUS,Z
	goto	P_T0_11
	bcf	pVENT
	goto	P_T0_12
P_T0_11	decfsz	SHIM_H,1
	goto	P_T0_12
	bcf	pVENT
P_T0_12	decfsz	SHIM_P,1
	goto	P_T0_13
	movlw	.40
	movwf	SHIM_P
	movfw	V_SPEED
	movwf	VENT_COPY
	bcf	STATUS,C
	rlf	VENT_COPY,1
	bcf	STATUS,C
	rlf	VENT_COPY,1
	bcf	STATUS,C
	rlf	VENT_COPY,0
	movwf	SHIM_H
	bsf	pVENT	
;   - 	
;  
P_T0_13	decfsz	tim_IND,1	;     ?
	goto	lp_E		;  -   ,   
	movlw	tt_ind		;  -    ANODS
	movwf	tim_IND		
;    7- 
	movfw	V_SPEED
	call	VENT_IND
	movwf	IND_VENT	
	DAT_OUT	pDOUT,pC2OUT	;   7- 
;         
	incf	IDEN,1
	movlw	34h
	subwf	IDEN,0
	btfss	STATUS,Z
	goto	lp_G
	movlw	31h
	movwf	IDEN
lp_G	movfw	IDEN
	movwf	FSR
	movfw	INDF
	DAT_OUT	pDOUT,pC1OUT
	movlw	30h
	subwf	IDEN,0
	call	ANOD_IND
	iorwf	IND_VENT,0
	movwf	ANODS
	DAT_OUT	pDOUT,pC2OUT

lp_E	
ext_prer 
	WR_COPY	STATUS_copy,STATUS,FSR_copy,FSR,w_copy
	bcf	INTCON,T0IF
	retfie


;***************************************************************
;  	
;***************************************************************
PERENOS_IN		;     EEDATA
	bcf	INTCON,GIE
	movlw	h'20'
	movwf	IDEN
ss1	clrwdt
	bsf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	h'20'
	subwf	IDEN,0
	movwf	EEADR
	bsf	EECON1,RD
	movfw	EEDATA
	movwf	TRANS
	movfw	IDEN
	movwf	FSR
	movfw	TRANS
	movwf	INDF
	incf	IDEN,1
	movlw	h'24'	;     
	subwf	IDEN,0
	btfss	STATUS,Z
	goto	ss1
	bcf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	31h	
	movwf	IDEN
	bsf	INTCON,GIE
	return
;***************************************************************
PERENOS_OUT		;     EEDATA
	bcf	INTCON,GIE
	bcf	PIR1,EEIF
	movlw	h'20'
	movwf	IDEN
uu1	clrwdt
	bsf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	h'20'
	subwf	IDEN,0		 
	movwf	EEADR
	movfw	IDEN
	movwf	FSR
	movfw	INDF
	movwf	EEDATA
	bsf	EECON1,WREN
	movlw	h'55'
	movwf	EECON2
	movlw	h'AA'
	movwf	EECON2	
	bsf	EECON1,WR
	bcf	EECON1,WREN
	bcf	STATUS,RP0
	bcf	STATUS,RP1
pov	btfss	PIR1,EEIF
	goto	pov
	bcf	PIR1,EEIF
	incf	IDEN,1
	movlw	h'24'	;      
	subwf	IDEN,0
	btfss	STATUS,Z
	goto	uu1
	movlw	31h	
	movwf	IDEN
	bsf	INTCON,GIE
	return

;***************************************************************
T_IZM			;  	
	clrwdt
	bcf	flag1,TT
	bsf	flag2,W_VENT
	bcf	flag,W_CONF
	bcf	INTCON,GIE		;  
	btfsc	count_RE,0
	goto	I_1
	btfss	flag,R_CONF		;  -?
	goto	I_2			;  
I_1	call	CONFIGURATION
	call	PREOBRAZ_T
	bcf	flag,FTDL
	bcf	flag,CL2
	movlw	Time_H/3		;  ~ 1 
	movwf	TIME_MT_H
	bcf	flag,R_CONF		; - 
	bsf	flag,W_CONF		;    
	incf	count_RE,1
I_3	bsf	INTCON,GIE
	return
I_2	incf	counter,1
	movlw	b'11111000'		  
	andwf	flag,1			;   ER1_2, ERR1, ERR2
	call	READ_T			;      
	bsf	INTCON,GIE		;  
	movfw	PCLATH
	movwf	PATH_COPY
	movlw	h'04'
	movwf	PCLATH
	bcf	INTCON,GIE		;  
	movlw	b'00000011'
	andwf	flag,0
	addwf	PCL,1
	goto	T_I_1			;    
	goto	T_I_5			;    
	goto	T_I_5			;    
	goto	T_I_2			;    /
T_I_5	bsf	flag,R_CONF		;     ,  -
	movfw	PATH_COPY
	movwf	PCLATH
	btfsc	counter,0
	goto	T_I_6
	goto	T_I_7
T_I_1	bcf	flag,R_CONF		;   , -   
T_I_6	call	PER_IND
T_I_7	movlw	T_Min
	subwf	A_Temper,0
	btfsc	STATUS,Z
	goto	P_D_1
	movlw	T_Max
	subwf	A_Temper,0
	btfsc	STATUS,Z
	goto	P_D_1
	bcf	flag2,AOFF
	bcf	flag2,DOFF
P_D_1	bsf	INTCON,GIE		;  
	return
T_I_2	bsf	flag,R_CONF		;    ,  -
	movfw	PATH_COPY
	movwf	PCLATH
	bsf	flag,ER1_2		;    /
	clrf	handl
	btfsc	counter,0
	goto	T_I_8
	movlw	b'01100000'		; '1'   
	movwf	IND1
	movlw	b'10011110'		; 'E'   '1E2'
	movwf	IND2
	movlw	b'11011010'		; '2'
	movwf	IND3	
	goto	T_I_4	
T_I_8	btfss	flag2,Hi
	goto	T_I_9
	bsf	flag2,AOFF
	bcf	flag2,DOFF
	call	IND_OP
	goto	T_I_4
T_I_9	bcf	flag2,AOFF
	bsf	flag2,DOFF
	call	IND_CL
T_I_4	bsf	INTCON,GIE		;  
	return


	
;***************************************************************************
;            
;***************************************************************************
PER_IND	
	movfw	PATH_COPY
	movwf	PCLATH	
	btfss	flag,ERR1
	goto	PER_1
PER_2	movfw	Tsal
	movwf	Tper			;     
	goto	PER_3
PER_1	btfss	flag,ERR2
	goto	PER_2
	movfw	Tvoz
	movwf	Tper			;     
PER_3	clrwdt
	bcf	flag1,lw
	btfss	Tper,7
	goto	ID_2
	bsf	flag1,lw
	movfw	Tper
	clrf	Tper
	subwf	Tper,1
	movlw	b'00000010'		;  
	movwf	IND1
ID_2	movfw	Tper
	movwf	Ts_copy
	PREOBR	Tper,Des,Ed
	movfw	Ts_copy
	movwf	Tper
	movf	Des,1
	btfss	STATUS,Z
	goto	loop2
	movfw	Ed
	call	DECODER
	btfss	flag1,lw
	goto	loop3
	movwf	IND2
	movlw	b'11000110'
	movwf	IND3
	goto	loop4
loop3	movwf	IND1
	movlw	b'11000110'
	movwf	IND2
	movlw	b'10011100'
	movwf	IND3
	goto	loop4
loop2	movfw	Des
	call	DECODER
	btfss	flag1,lw
	goto	loop5
	movwf	IND2
	movfw	Ed
	call	DECODER
	movwf	IND3
	goto	loop4
loop5	movwf	IND1
	movfw	Ed
	call	DECODER
	movwf	IND2
	movlw	b'11000110'
	movwf	IND3
	goto	loop4
loop4	clrwdt
	return

	end
